package com.tzld.piaoquan.ad.engine.commons.score.feature;

import com.tzld.piaoquan.ad.engine.commons.base.AdItemBytesFeature;
import com.tzld.piaoquan.ad.engine.commons.base.AdRequestContextBytesFeature;
import com.tzld.piaoquan.ad.engine.commons.base.UserAdBytesFeature;
import com.tzld.piaoquan.ad.engine.commons.enums.VlogAdFeatureGroup;
import com.tzld.piaoquan.recommend.server.gen.recommend.FeatureGroup;
import com.tzld.piaoquan.recommend.server.gen.recommend.GroupedFeature;
import com.tzld.piaoquan.recommend.server.gen.recommend.LRSamples;
import com.tzld.piaoquan.recommend.server.gen.recommend.BaseFeature;



import java.util.ArrayList;
import java.util.List;

public class VlogAdCtrLRFeatureExtractor extends LRBytesFeatureExtractorBase {

    public VlogAdCtrLRFeatureExtractor() {
        super();
    }

    // TODO
    // 补充待抽取的context feature
    public void getContextFeatures(AdRequestContextBytesFeature requestContextBytes) {
        makeFea(VlogAdFeatureGroup.MACHINEINFO_BRAND, requestContextBytes.getMachineinfo_brand());
        makeFea(VlogAdFeatureGroup.MACHINEINFO_MODEL, requestContextBytes.getMachineinfo_model());
        makeFea(VlogAdFeatureGroup.MACHINEINFO_SDKVERSION, requestContextBytes.getMachineinfo_sdkversion());
        makeFea(VlogAdFeatureGroup.MACHINEINFO_SYSTEM, requestContextBytes.getMachineinfo_system());
        makeFea(VlogAdFeatureGroup.MACHINEINFO_WECHATVERSION, requestContextBytes.getMachineinfo_brand());

        makeFea(VlogAdFeatureGroup.DAY, requestContextBytes.getWeek());
        makeFea(VlogAdFeatureGroup.WEEK, requestContextBytes.getWeek());
        makeFea(VlogAdFeatureGroup.HOUR, requestContextBytes.getHour());

    }

    //TODO
    public void getUserFeatures(UserAdBytesFeature userAdBytesFeature) {

        // 1day features
        makeFea(VlogAdFeatureGroup.USER_1DAY_EXP, userAdBytesFeature.getDay1_cnt_features().get("view"));
        makeFea(VlogAdFeatureGroup.USER_1DAY_CLICK, userAdBytesFeature.getDay1_cnt_features().get("click"));
        makeFea(VlogAdFeatureGroup.USER_1DAY_SHARE, userAdBytesFeature.getDay1_cnt_features().get("ctr"));
        makeFea(VlogAdFeatureGroup.USER_1DAY_RETURN, userAdBytesFeature.getDay1_cnt_features().get("cvr"));

        // 3day features
        makeFea(VlogAdFeatureGroup.USER_3DAY_EXP, userAdBytesFeature.getDay3_cnt_features().get("view"));
        makeFea(VlogAdFeatureGroup.USER_3DAY_CLICK, userAdBytesFeature.getDay3_cnt_features().get("click"));
        makeFea(VlogAdFeatureGroup.USER_3DAY_SHARE, userAdBytesFeature.getDay3_cnt_features().get("ctr"));
        makeFea(VlogAdFeatureGroup.USER_3DAY_RETURN, userAdBytesFeature.getDay3_cnt_features().get("cvr"));

        // 7day features
        makeFea(VlogAdFeatureGroup.USER_7DAY_EXP, userAdBytesFeature.getDay7_cnt_features().get("view"));
        makeFea(VlogAdFeatureGroup.USER_7DAY_CLICK, userAdBytesFeature.getDay7_cnt_features().get("click"));
        makeFea(VlogAdFeatureGroup.USER_7DAY_SHARE, userAdBytesFeature.getDay7_cnt_features().get("ctr"));
        makeFea(VlogAdFeatureGroup.USER_7DAY_RETURN, userAdBytesFeature.getDay7_cnt_features().get("cvr"));

        // 3month features
        makeFea(VlogAdFeatureGroup.USER_3MONTH_EXP, userAdBytesFeature.getMonth3_cnt_features().get("view"));
        makeFea(VlogAdFeatureGroup.USER_3MONTH_CLICK, userAdBytesFeature.getMonth3_cnt_features().get("click"));
        makeFea(VlogAdFeatureGroup.USER_3MONTH_SHARE, userAdBytesFeature.getMonth3_cnt_features().get("ctr"));
        makeFea(VlogAdFeatureGroup.USER_3MONTH_RETURN, userAdBytesFeature.getMonth3_cnt_features().get("cvr"));


    }

    public void getItemFeature(AdItemBytesFeature item) {

        // Vdieo
        makeFea(VlogAdFeatureGroup.ADID, item.getAdId());
        makeFea(VlogAdFeatureGroup.CREATIVE, item.getCreative());
        makeFea(VlogAdFeatureGroup.CAMPAIGIN, item.getCampaignId());
        makeFea(VlogAdFeatureGroup.ADVERID, item.getAdvertiserId());



        // 1day features
        makeFea(VlogAdFeatureGroup.ITEM_1DAY_EXP, item.getDay1_cnt_features().get("view"));
        makeFea(VlogAdFeatureGroup.ITEM_1DAY_CLICK, item.getDay1_cnt_features().get("click"));
        makeFea(VlogAdFeatureGroup.ITEM_1DAY_SHARE, item.getDay1_cnt_features().get("ctr"));
        makeFea(VlogAdFeatureGroup.ITEM_1DAY_RETURN, item.getDay1_cnt_features().get("cvr"));

        // 3day features
        makeFea(VlogAdFeatureGroup.ITEM_3DAY_EXP, item.getDay1_cnt_features().get("view"));
        makeFea(VlogAdFeatureGroup.ITEM_3DAY_CLICK, item.getDay1_cnt_features().get("click"));
        makeFea(VlogAdFeatureGroup.ITEM_3DAY_SHARE, item.getDay1_cnt_features().get("ctr"));
        makeFea(VlogAdFeatureGroup.ITEM_3DAY_RETURN, item.getDay1_cnt_features().get("cvr"));


        // 7day features
        makeFea(VlogAdFeatureGroup.ITEM_7DAY_EXP, item.getDay1_cnt_features().get("view"));
        makeFea(VlogAdFeatureGroup.ITEM_7DAY_CLICK, item.getDay1_cnt_features().get("click"));
        makeFea(VlogAdFeatureGroup.ITEM_7DAY_SHARE, item.getDay1_cnt_features().get("ctr"));
        makeFea(VlogAdFeatureGroup.ITEM_7DAY_RETURN, item.getDay1_cnt_features().get("cvr"));


        // 3month features
        makeFea(VlogAdFeatureGroup.ITEM_3MONTH_EXP, item.getMonth3_cnt_features().get("view"));
        makeFea(VlogAdFeatureGroup.ITEM_3MONTH_CLICK, item.getMonth3_cnt_features().get("click"));
        makeFea(VlogAdFeatureGroup.ITEM_3MONTH_SHARE, item.getMonth3_cnt_features().get("ctr"));
        makeFea(VlogAdFeatureGroup.ITEM_3MONTH_RETURN, item.getMonth3_cnt_features().get("cvr"));

    }

    @Override
    public synchronized LRSamples single(UserAdBytesFeature userAdBytesFeature,
                                         AdItemBytesFeature videoBytesFeature,
                                         AdRequestContextBytesFeature requestContextBytesFeature) {
        features.clear();
        // extract features
        getUserFeatures(userAdBytesFeature);
        getContextFeatures(requestContextBytesFeature);
        getItemFeature(videoBytesFeature);

        LRSamples.Builder lr = com.tzld.piaoquan.recommend.server.gen.recommend.LRSamples.newBuilder();
        lr.setGroupNum(groupCount);
        List<FeatureGroup> keys = new ArrayList<>(features.keySet());
        int count = 0;
        for(FeatureGroup group : keys) {
            List<BaseFeature> fea = features.get(group);
            GroupedFeature.Builder gf = GroupedFeature.newBuilder();
            gf.setGroup(group);
            gf.setCount(fea.size());
            gf.addAllFeatures(fea);
            count += fea.size();
            lr.addFeatures(gf);
        }
        lr.setCount(count);
        return lr.build();
    }


}
